## unicorn-engine 2.0.1.post1

=== CMakeLists.txt ===
--- 
+++ 
@@ -45,7 +45,7 @@
 
 set(UNICORN_VERSION_MAJOR 2)
 set(UNICORN_VERSION_MINOR 0)
-set(UNICORN_VERSION_PATCH 0)
+set(UNICORN_VERSION_PATCH 1)
 
 include(bundle_static.cmake)
