=== debian/changelog ===
unicorn-engine (2.0.1.post1-4build2) noble; urgency=medium

  * No-change upload to remove support of ruby3.1.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Tue, 20 Feb 2024 04:53:26 -0300

unicorn-engine (2.0.1.post1-4build1) noble; urgency=medium

  * No-change upload to add support for ruby3.2.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Fri, 02 Feb 2024 04:55:50 -0300

unicorn-engine (2.0.1.post1-4) unstable; urgency=medium

  * Fix build error with pybuild in dh_auto_clean

 -- Timo Röhling <roehling@debian.org>  Tue, 15 Aug 2023 18:04:35 +0200

unicorn-engine (2.0.1.post1-3) unstable; urgency=medium

  * Properly execute dh_auto_clean (Closes: #1048756)

 -- Timo Röhling <roehling@debian.org>  Tue, 15 Aug 2023 17:03:51 +0200

unicorn-engine (2.0.1.post1-2) unstable; urgency=medium

  * Make package cross-buildable
  * Bump Standards-Version to 4.6.2

 -- Timo Röhling <roehling@debian.org>  Mon, 19 Jun 2023 00:07:41 +0200

unicorn-engine (2.0.1.post1-1) unstable; urgency=medium

  * New upstream version 2.0.1.post1

 -- Timo Röhling <roehling@debian.org>  Fri, 25 Nov 2022 11:50:59 +0100
