## unicorn-engine 2.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # CMake setup for Unicorn 2.
 # By Huitao Chen & Nguyen Anh Quynh, 2019-2020
 
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.5)
 
 # Only required for MSVC, but we can't know the compiler at this point because we haven't
 # called enable_language() or project(), and if we did that it would lock in the old
@@ -17,6 +17,14 @@
     cmake_policy(SET CMP0092 NEW)
 endif()
 
+# Honor visibility properties for all target types.
+cmake_policy(SET CMP0063 NEW)
+
+option(ZIG_BUILD "Enable zig build" OFF)
+if(ZIG_BUILD)
+    include(cmake/zig.cmake)
+endif()
+
 # Workaround to fix wrong compiler on macos.
 if(APPLE AND NOT CMAKE_C_COMPILER)
     set(CMAKE_C_COMPILER "/usr/bin/cc")
@@ -44,10 +52,10 @@
 set(CMAKE_C_STANDARD 11)
 
 set(UNICORN_VERSION_MAJOR 2)
-set(UNICORN_VERSION_MINOR 0)
+set(UNICORN_VERSION_MINOR 1)
 set(UNICORN_VERSION_PATCH 1)
 
-include(bundle_static.cmake)
+include(cmake/bundle_static.cmake)
 
 # Even though we generate shared lib and static archive at the same time, we still support
 # using unicorn as a subdirectory so we have to respect BUILD_SHARED_LIBS.
@@ -56,6 +64,7 @@
 # compatability.
 option(BUILD_SHARED_LIBS "Build shared instead of static library" ${PROJECT_IS_TOP_LEVEL})
 option(UNICORN_FUZZ "Enable fuzzing" OFF)
+option(UNICORN_LOGGING "Enable logging" OFF)
 option(UNICORN_BUILD_TESTS "Build unicorn tests" ${PROJECT_IS_TOP_LEVEL})
 option(UNICORN_INSTALL "Enable unicorn installation" ${PROJECT_IS_TOP_LEVEL})
 set(UNICORN_ARCH "x86;arm;aarch64;riscv;mips;sparc;m68k;ppc;s390x;tricore" CACHE STRING "Enabled unicorn architectures")
@@ -84,6 +93,14 @@
     qemu/tcg
 )
 
+# QEMU logging facility
+if (UNICORN_LOGGING)
+    add_compile_options(-DUNICORN_LOGGING)
+endif()
+
+# Some distributions on some rare architecures don't auto link atomic for us and
+# we do this manually by adding flags.
+set(ATOMIC_LINKAGE_FIX FALSE)
 if(MSVC)
     if(CMAKE_SIZEOF_VOID_P EQUAL 8)
         set(MSVC_FLAG  -D__x86_64__)
@@ -109,22 +126,25 @@
     add_compile_options($<$<COMPILE_LANGUAGE:C>:/wd4267>)
 
     # handle msvcrt setting being passed in CMAKE_C_FLAGS
-    if(DEFINED CMAKE_MSVC_RUNTIME_LIBRARY)
-        # do not support other methods of setting this (it would be more conformant, tho)
-        message(FATAL_ERROR "please set msvcrt via CMAKE_C_FLAGS")
-    endif()
-    if(CMAKE_C_FLAGS MATCHES "[/-]MTd")
-        set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreadedDebug")
-    elseif(CMAKE_C_FLAGS MATCHES "[/-]MDd")
-        set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreadedDebugDLL")
-    elseif(CMAKE_C_FLAGS MATCHES "[/-]MT")
-        set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded")
-    elseif(CMAKE_C_FLAGS MATCHES "[/-]MD")
-        set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreadedDLL")
-    endif()
-
-    # prevent the arg from occurring more than once (not a big deal, just to keep tidy)
-    string(REGEX REPLACE "[/-]M[TD]d?" "" CMAKE_C_FLAGS ${CMAKE_C_FLAGS})
+    if(CMAKE_C_FLAGS MATCHES "[/-]M[TD]d?")
+        # ensure CMAKE_MSVC_RUNTIME_LIBRARY is not already defined
+        if(DEFINED CMAKE_MSVC_RUNTIME_LIBRARY)
+            message(FATAL_ERROR "please set the runtime library via either CMAKE_C_FLAGS or CMAKE_MSVC_RUNTIME_LIBRARY, not both")
+        endif()
+
+        if(CMAKE_C_FLAGS MATCHES "[/-]MTd")
+            set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreadedDebug")
+        elseif(CMAKE_C_FLAGS MATCHES "[/-]MDd")
+            set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreadedDebugDLL")
+        elseif(CMAKE_C_FLAGS MATCHES "[/-]MT")
+            set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded")
+        elseif(CMAKE_C_FLAGS MATCHES "[/-]MD")
+            set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreadedDLL")
+        endif()
+
+        # prevent the arg from occurring more than once (not a big deal, just to keep tidy)
+        string(REGEX REPLACE "[/-]M[TD]d?" "" CMAKE_C_FLAGS ${CMAKE_C_FLAGS})
+    endif()
 else()
     if(MINGW)
         execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpmachine
@@ -186,6 +206,7 @@
             string(FIND "${UC_COMPILER_MACRO}" "__arm__" UC_RET)
             if(${UC_RET} GREATER_EQUAL "0")
                 set(UNICORN_TARGET_ARCH "arm")
+                set(ATOMIC_LINKAGE_FIX TRUE)
                 break()
             endif()
             string(FIND "${UC_COMPILER_MACRO}" "__aarch64__" UC_RET)
@@ -196,11 +217,13 @@
             string(FIND "${UC_COMPILER_MACRO}" "__mips__" UC_RET)
             if(${UC_RET} GREATER_EQUAL "0")
                 set(UNICORN_TARGET_ARCH "mips")
+                set(ATOMIC_LINKAGE_FIX TRUE)
                 break()
             endif()
             string(FIND "${UC_COMPILER_MACRO}" "__sparc__" UC_RET)
             if(${UC_RET} GREATER_EQUAL "0")
                 set(UNICORN_TARGET_ARCH "sparc")
+                set(ATOMIC_LINKAGE_FIX TRUE)
                 break()
             endif()
             string(FIND "${UC_COMPILER_MACRO}" "__ia64__" UC_RET)
@@ -211,16 +234,19 @@
             string(FIND "${UC_COMPILER_MACRO}" "_ARCH_PPC" UC_RET)
             if(${UC_RET} GREATER_EQUAL "0")
                 set(UNICORN_TARGET_ARCH "ppc")
+                set(ATOMIC_LINKAGE_FIX TRUE)
                 break()
             endif()
             string(FIND "${UC_COMPILER_MACRO}" "__riscv" UC_RET)
             if(${UC_RET} GREATER_EQUAL "0")
                 set(UNICORN_TARGET_ARCH "riscv")
+                set(ATOMIC_LINKAGE_FIX TRUE)
                 break()
             endif()
             string(FIND "${UC_COMPILER_MACRO}" "__s390__" UC_RET)
             if(${UC_RET} GREATER_EQUAL "0")
                 set(UNICORN_TARGET_ARCH "s390")
+                set(ATOMIC_LINKAGE_FIX TRUE)
                 break()
             endif()
             string(FIND ${UC_COMPILER_MACRO} "__tricore__" UC_RET)
@@ -275,6 +301,13 @@
     if(UNICORN_TRACER)
         set (EXTRA_CFLAGS "${EXTRA_CFLAGS} -DUNICORN_TRACER")
     endif()
+    if (ATOMIC_LINKAGE_FIX)
+        set (EXTRA_CFLAGS "${EXTRA_CFLAGS} -latomic")
+    endif()
+    if (CMAKE_OSX_SYSROOT)
+        # https://github.com/unicorn-engine/unicorn/issues/1917
+        set (EXTRA_CFLAGS "${EXTRA_CFLAGS} -isysroot ${CMAKE_OSX_SYSROOT} ")
+    endif()
 
     set(TARGET_LIST "--target-list=")
     if(UNICORN_HAS_X86)
@@ -284,35 +317,3 @@
         set(TARGET_LIST "${TARGET_LIST}arm-softmmu, ")
     endif()
     if(UNICORN_HAS_AARCH64)
-        set(TARGET_LIST "${TARGET_LIST}aarch64-softmmu, ")
-    endif()
-    if(UNICORN_HAS_M68K)
-        set(TARGET_LIST "${TARGET_LIST}m68k-softmmu, ")
-    endif()
-    if(UNICORN_HAS_MIPS)
-        set(TARGET_LIST "${TARGET_LIST}mips-softmmu, mipsel-softmmu, mips64-softmmu, mips64el-softmmu, ")
-    endif()
-    if(UNICORN_HAS_SPARC)
-        set(TARGET_LIST "${TARGET_LIST}sparc-softmmu, sparc64-softmmu, ")
-    endif()
-    if(UNICORN_HAS_PPC)
-        set(TARGET_LIST "${TARGET_LIST}ppc-softmmu, ppc64-softmmu, ")
-    endif()
-    if(UNICORN_HAS_RISCV)
-        set(TARGET_LIST "${TARGET_LIST}riscv32-softmmu, riscv64-softmmu, ")
-    endif()
-    if(UNICORN_HAS_S390X)
-        set(TARGET_LIST "${TARGET_LIST}s390x-softmmu, ")
-    endif()
-    if (UNICORN_HAS_TRICORE)
-        set (TARGET_LIST "${TARGET_LIST}tricore-softmmu, ")
-    endif()
-    set(TARGET_LIST "${TARGET_LIST} ")
-
-    # GEN config-host.mak & target directories
-    execute_process(COMMAND sh ${CMAKE_CURRENT_SOURCE_DIR}/qemu/configure
-        --cc=${CMAKE_C_COMPILER}
-        ${EXTRA_CFLAGS}
-        ${TARGET_LIST}
-        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
-    )
