=== debian/changelog ===
unicorn-engine (2.1.1-2) unstable; urgency=medium

  * Fix FTBFS with s390x (big endian issue) (Closes: #1088921)

 -- Timo Röhling <roehling@debian.org>  Thu, 05 Dec 2024 11:57:13 +0100

unicorn-engine (2.1.1-1) unstable; urgency=medium

  * New upstream version 2.1.1
  * Refresh patches (no functional changes)
  * Wrap and sort Debian package files
  * Bump Standards-Version to 4.7.0

 -- Timo Röhling <roehling@debian.org>  Mon, 02 Dec 2024 09:07:12 +0100

unicorn-engine (2.0.1.post1-5) unstable; urgency=medium

  * Fix FTBFS in ruby gem (Closes: #1075608)

 -- Timo Röhling <roehling@debian.org>  Fri, 16 Aug 2024 22:23:20 +0200

unicorn-engine (2.0.1.post1-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063012

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 21:11:59 +0000
