=== debian/control ===
--- 
+++ 
@@ -3,9 +3,10 @@
 Priority: optional
 Maintainer: Timo Röhling <roehling@debian.org>
 Build-Depends:
+ cmake,
  debhelper-compat (= 13),
- cmake,
  dh-sequence-ruby,
+ dpkg-dev (>= 1.22.5),
  gem2deb,
  pkgconf,
  rake,
@@ -16,7 +17,7 @@
  python3-all,
  python3-setuptools,
 Homepage: https://unicorn-engine.org
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 XS-Ruby-Versions: all
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/roehling/unicorn-engine.git
@@ -30,7 +31,13 @@
  instrumentation hooks for various CPU events. This makes Unicorn well
  suited for malware analysis and reverse engineering.
 
-Package: libunicorn2
+Package: libunicorn2t64
+Provides:
+ ${t64:Provides},
+Replaces:
+ libunicorn2,
+Breaks:
+ libunicorn2 (<< ${source:Version}),
 Architecture: any
 Multi-Arch: same
 Depends:
@@ -46,8 +53,8 @@
 Architecture: any
 Multi-Arch: same
 Depends:
+ libunicorn2t64 (= ${binary:Version}),
  ${misc:Depends},
- libunicorn2 (= ${binary:Version}),
 Description: ${source:Synopsis} (development headers)
  ${source:Extended-Description}
  .
@@ -57,9 +64,9 @@
 Section: python
 Architecture: all
 Depends:
+ libunicorn2t64 (>= ${source:Upstream-Version}),
  ${misc:Depends},
  ${python3:Depends},
- libunicorn2 (>= ${source:Upstream-Version}),
 Description: ${source:Synopsis} (Python 3 bindings)
  ${source:Extended-Description}
  .
